public class Elevator {
	private int currentFloor = 0;
	private boolean betweenFloors = false; /* Between currentFloor and the one above it. */
	private Direction direction = Direction.NONE;
	private boolean stoppingNextFloor = false;
	private boolean emergency = false;

	public Elevator(int currentFloor) {
		this.currentFloor = currentFloor;
	}

	public void goUp() {
		if (emergency) return;
		stoppingNextFloor = false;
		direction = Direction.UP;
	}

	public void goDown() {
		if (emergency) return;
		stoppingNextFloor = false;
		direction = Direction.DOWN;
	}

	public void stopElevator() {
		direction = Direction.NONE;
	}

	public void stopNextFloor() {
		stoppingNextFloor = true;
	}

	public void emergencyStop() {
		emergency = true;
		direction = Direction.NONE;
	}

	public void cancelEmergency() {
		emergency = false;
	}

	public void move() {
		if (emergency) return;
		switch (direction) {
		case DOWN:
			/* Go halfway below. */
			if (!betweenFloors) currentFloor--;
			betweenFloors = !betweenFloors;
			break;
		case UP:
			/* Go halfway above. */
			if (betweenFloors) currentFloor++;
			betweenFloors = !betweenFloors;
			break;
		default:
			break;
		}
	}

	public int getCurrentFloor() {
		return currentFloor;
	}

	public boolean getBetweenFloors() {
		return betweenFloors;
	}

	public Direction getDirection() {
		return direction;
	}
}
